#define INCL_DOSPROCESS     /* Process and thread values */
#define INCL_DOSEXCEPTIONS  /* DOS exception values      */
#define INCL_DOSERRORS      /* DOS error values          */
#define INCL_DOSSESMGR

#define INCL_TYPES
#include <stdint.h>
#include <os2.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define HF_STDOUT 1      /* Standard output handle */

int
main()
{
    APIRET      rc;
    CHAR        szPgmName[] = "DosSetExceptionHandler.exe";
    PID         pidProcess  = 0;
    RESULTCODES ChildRC     = {0}; // Results from child process

//-------------------------------------------------------------------------
/*
    STARTDATA  sd;
    CHAR       szBuf[CCHMAXPATH];
    ULONG      ulSessionID;

    sd.Length        = sizeof(sd);              // Length of the structure
    sd.Related       = SSF_RELATED_CHILD;       // Unrelated session      
    sd.FgBg          = SSF_FGBG_FORE;           // In the foreground      
    sd.TraceOpt      = SSF_TRACEOPT_NONE;       // No tracing             

    sd.PgmTitle      = (PSZ) NULL;              // Title is PgmName       
    sd.PgmName       = szPgmName;               // Address of szPgmName   
    sd.PgmInputs     = (PBYTE) NULL;            // No command line args   
    sd.TermQ         = (PBYTE) NULL;            // No terminal queue      
    sd.Environment   = (PBYTE) NULL;            // Inherits environment   

    sd.InheritOpt    = SSF_INHERTOPT_PARENT;    // Uses parent environment

    sd.SessionType   = SSF_TYPE_WINDOWABLEVIO;  // PM session           
    sd.IconFile      = (PSZ) NULL;              // Uses default icon    
    sd.PgmHandle     = 0;                       // Used by Win calls    
    sd.PgmControl    = SSF_CONTROL_MAXIMIZE;    // Starts app maximized 
    sd.InitXPos      = 0;                       // Lower left corner    
    sd.InitYPos      = 0;                       // Lower left corner    
    sd.InitXSize     = 0;                       // Ignored for maximized
    sd.InitYSize     = 0;                       // Ignored for maximized
    sd.Reserved      = 0;                       //
    sd.ObjectBuffer  = szBuf;                   // Fail-name buffer     
    sd.ObjectBuffLen = sizeof(szBuf);           // Buffer length        

    rc = DosStartSession(&sd, &ulSessionID, &pidProcess);
*/
//-------------------------------------------------------------------------

    UCHAR   uchLoadError[CCHMAXPATH] = {0}; // Error info from DosExecPgm
    rc = DosExecPgm(uchLoadError,           // Object name buffer
                    sizeof(uchLoadError),   // Length of object name buffer
                    EXEC_ASYNCRESULT,       // Asynchronous/Trace flags
                    0,                      // Argument string
                    0,                      // Environment string
                    &ChildRC,               // Returns pid of process on an asynchronous request
                    szPgmName);             // Program file name
  
    if (rc)
    {
        printf("Parent>> Error starting new session %d\r\n", rc);
        return;
    }
    pidProcess = ChildRC.codeTerminate;

//-------------------------------------------------------------------------

    printf("Parent>> child PID: 0x%x\n",pidProcess);
    printf("Parent>> prees any key to send XCPT_SIGNAL_INTR to the child\n");
    getchar();

    rc = DosSendSignalException ( pidProcess,          // Process to interrupt
                                  XCPT_SIGNAL_INTR );  // Send this signal

    printf("Parent>> DosSendSignalException  rc = %u\n\n", rc);

    PID pidChild;                               /* pid for child process       */
    rc = DosWaitChild(DCWA_PROCESS,             /* Look at only the process specified */
                      DCWW_WAIT,                /* Wait until a child terminates      */
                      &ChildRC,                 /* Termination codes returned         */
                      &pidChild,                /* pid of terminating process         */
                      ChildRC.codeTerminate);   /* Process (pid) to look at  */
  
    if (rc != NO_ERROR)
    {
       printf("Parent>> DosWaitChild error: return code = %u\n",rc);
    }
    else
    {
       printf("\nParent>> Child complete.  Termination Code: %u  Return Code: %u\n",
               ChildRC.codeTerminate, ChildRC.codeResult);
    }
}
