#define INCL_DOSPROCESS       /* DOS process values (for DosSleep) */
#define INCL_DOSEXCEPTIONS    /* DOS exception values */
#define INCL_ERRORS           /* DOS error values     */

#define INCL_TYPES
#include <stdint.h>
#include <os2.h>
#include <stdio.h>

ULONG _System MyTermHandler( PEXCEPTIONREPORTRECORD       p1,
                             PEXCEPTIONREGISTRATIONRECORD p2,
                             PCONTEXTRECORD               p3,
                             PVOID                        pv );

int main (VOID)
{
  EXCEPTIONREGISTRATIONRECORD RegRec  = {0};     /* Exception Registration Record */
  APIRET      rc      = NO_ERROR;   /* Return code                   */
  ULONG       times   = 0;
  int ii;

  /* Add MyTermHandler to this thread's chain of exception handlers */

  RegRec.ExceptionHandler = (ERR)MyTermHandler;
  rc = DosSetExceptionHandler( &RegRec );
  if (rc)
  {
     printf("Child>> DosSetExceptionHandler error: return code = %u\n",rc);
     return 1;
  }
  rc = DosSetSignalExceptionFocus(SIG_SETFOCUS, &times );
  if (rc)
  {
     printf("Child>> DosSetSignalExceptionFocus error: return code = %u\n",rc);
  }

  printf("Child>> Dady, I am waiting for your signal :)\n");

  DosSleep(1000000);   /* Give user plenty of time to comply... */

  rc = DosSetSignalExceptionFocus(SIG_UNSETFOCUS, &times );
  if (rc)
  {
     printf("Child>> DosSetSignalExceptionFocus error: return code = %u\n",rc);
  }
  rc = DosUnsetExceptionHandler( &RegRec );

  if (rc)
  {
     printf("Child>> DosUnsetExceptionHandler error: return code = %u\n",rc);
     return 1;
  }
  return NO_ERROR;
}
/***************************************************************************/
ULONG _System MyTermHandler( PEXCEPTIONREPORTRECORD       p1,
                             PEXCEPTIONREGISTRATIONRECORD p2,
                             PCONTEXTRECORD               p3,
                             PVOID                        pv )
{
  printf("*** MyTermHandler entered: ExceptionNum = %x\n",p1->ExceptionNum);

  switch( p1->ExceptionNum)
  {
   case XCPT_SIGNAL:
   {
      printf(" XCPT_SIGNAL");
      switch( p1->ExceptionInfo[0] )
      {
        case XCPT_SIGNAL_INTR:     { printf("_INTR"); break; }
        case XCPT_SIGNAL_KILLPROC: { printf("_KILLPROC"); break; }
        case XCPT_SIGNAL_BREAK:    { printf("_BREAK"); break; }
        default:;
      }
      printf("\n"); break;
   }
   case XCPT_PROCESS_TERMINATE:       { printf(" Process Terminate \n"); break;}
   case XCPT_ASYNC_PROCESS_TERMINATE: { printf(" Async Process Term\n"); break;}
   case XCPT_UNWIND:                  { printf(" XCPT_UNWIND\n");        break;}
   default:;
  }

  //DosSleep(10000L);

  return XCPT_CONTINUE_SEARCH;          /* Exception not resolved...*/
}
